import * as i0 from '@angular/core';
import { Injectable, EventEmitter, Directive, Input, Output, inject } from '@angular/core';
import { toSignal } from '@angular/core/rxjs-interop';
import { Subject, merge } from 'rxjs';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { provide, provideMulti } from '@angularity/core';

class ComponentValueAccessorHost {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.3", ngImport: i0, type: ComponentValueAccessorHost, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.0.3", ngImport: i0, type: ComponentValueAccessorHost }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.3", ngImport: i0, type: ComponentValueAccessorHost, decorators: [{
            type: Injectable
        }] });
class SimpleComponentValueAccessorHost {
    constructor() {
        this.valueInput$ = new Subject();
        this.valueChange$ = new EventEmitter();
        this.disabled$ = new Subject();
        this.touched$ = new EventEmitter();
        this.value = toSignal(merge(this.valueInput$, this.valueChange$));
        this.disabled = toSignal(this.disabled$);
    }
    // prettier-ignore
    set valueInput(v) { this.valueInput$.next(v); }
    // prettier-ignore
    set disabledInput(v) { this.disabled$.next(v); }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.3", ngImport: i0, type: SimpleComponentValueAccessorHost, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "19.0.3", type: SimpleComponentValueAccessorHost, isStandalone: true, inputs: { valueInput: ["value", "valueInput"], disabledInput: ["disabled", "disabledInput"] }, outputs: { valueChange$: "valueChange", touched$: "touched" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.3", ngImport: i0, type: SimpleComponentValueAccessorHost, decorators: [{
            type: Directive
        }], propDecorators: { valueInput: [{
                type: Input,
                args: ['value']
            }], valueChange$: [{
                type: Output,
                args: ['valueChange']
            }], disabledInput: [{
                type: Input,
                args: ['disabled']
            }], touched$: [{
                type: Output,
                args: ['touched']
            }] } });

class ComponentValueAccessor {
    constructor() {
        this.host = inject(ComponentValueAccessorHost, { self: true });
    }
    writeValue(value) {
        this.host.valueInput$.next(value);
    }
    registerOnChange(fn) {
        this.host.valueChange$.subscribe({ next: fn });
    }
    registerOnTouched(fn) {
        this.host.touched$.subscribe({ next: fn });
    }
    setDisabledState(disabled) {
        this.host.disabled$.next(disabled);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.0.3", ngImport: i0, type: ComponentValueAccessor, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.0.3", ngImport: i0, type: ComponentValueAccessor }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.0.3", ngImport: i0, type: ComponentValueAccessor, decorators: [{
            type: Injectable
        }] });

function provideComponentValueAccessor(host) {
    return [
        provide({
            token: ComponentValueAccessorHost,
            useExisting: host,
        }),
        provideMulti({
            token: NG_VALUE_ACCESSOR,
            useClass: ComponentValueAccessor,
        }),
    ];
}

/**
 * Generated bundle index. Do not edit.
 */

export { ComponentValueAccessor, ComponentValueAccessorHost, SimpleComponentValueAccessorHost, provideComponentValueAccessor };
//# sourceMappingURL=angularity-forms.mjs.map
